// Class: openfl._internal.renderer.cairo.CairoGraphics

var $global = typeof window != "undefined" ? window : typeof global != "undefined" ? global : typeof self != "undefined" ? self : this

$global.Object.defineProperty(exports, "__esModule", {value: true});

var __map_reserved = {};

// Imports

var $hxClasses = require("./../../../../hxClasses_stub").default;
var $import = require("./../../../../import_stub").default;
function openfl__$internal_renderer_DrawCommandBuffer() {return require("./../../../../openfl/_internal/renderer/DrawCommandBuffer");}
function openfl_geom_Matrix() {return require("./../../../../openfl/geom/Matrix");}
function openfl_geom_Point() {return require("./../../../../openfl/geom/Point");}
function lime_graphics_cairo__$CairoPattern_CairoPattern_$Impl_$() {return require("./../../../../lime/graphics/cairo/_CairoPattern/CairoPattern_Impl_");}
function openfl__$Vector_Vector_$Impl_$() {return require("./../../../../openfl/_Vector/Vector_Impl_");}
function openfl__$internal_renderer_DrawCommandReader() {return require("./../../../../openfl/_internal/renderer/DrawCommandReader");}
function Type() {return require("./../../../../Type");}
function Std() {return require("./../../../../Std");}
function lime_math_Matrix3() {return require("./../../../../lime/math/Matrix3");}
function lime_math_Vector2() {return require("./../../../../lime/math/Vector2");}

// Constructor

var CairoGraphics = function(){}

// Meta

CairoGraphics.__name__ = ["openfl","_internal","renderer","cairo","CairoGraphics"];
CairoGraphics.prototype = {
	
};
CairoGraphics.prototype.__class__ = $hxClasses["openfl._internal.renderer.cairo.CairoGraphics"] = CairoGraphics;

// Init



// Statics

CairoGraphics.closePath = function(strokeBefore) {
	if(strokeBefore == null) {
		strokeBefore = false;
	}
	if(CairoGraphics.strokePattern == null) {
		return;
	}
	if(!strokeBefore) {
		CairoGraphics.cairo.closePath();
	}
	CairoGraphics.cairo.set_source(CairoGraphics.strokePattern);
	if(!CairoGraphics.hitTesting) {
		CairoGraphics.cairo.strokePreserve();
	}
	if(strokeBefore) {
		CairoGraphics.cairo.closePath();
	}
	CairoGraphics.cairo.newPath();
}
CairoGraphics.createGradientPattern = function(type,colors,alphas,ratios,matrix,spreadMethod,interpolationMethod,focalPointRatio) {
	var pattern = null;
	var point = null;
	var point2 = null;
	var releaseMatrix = false;
	if(matrix == null) {
		matrix = (openfl_geom_Matrix().default).__pool.get();
		releaseMatrix = true;
	}
	switch(type) {
	case 0:
		point = (openfl_geom_Point().default).__pool.get();
		point.setTo(-819.2,0);
		matrix.__transformPoint(point);
		point2 = (openfl_geom_Point().default).__pool.get();
		point2.setTo(819.2,0);
		matrix.__transformPoint(point2);
		point.x += CairoGraphics.graphics.__bounds.x;
		point2.x += CairoGraphics.graphics.__bounds.x;
		point.y += CairoGraphics.graphics.__bounds.y;
		point2.y += CairoGraphics.graphics.__bounds.y;
		pattern = (lime_graphics_cairo__$CairoPattern_CairoPattern_$Impl_$().default).createLinear(point.x,point.y,point2.x,point2.y);
		break;
	case 1:
		point = (openfl_geom_Point().default).__pool.get();
		point.setTo(1638.4,0);
		matrix.__transformPoint(point);
		var x = matrix.tx + CairoGraphics.graphics.__bounds.x;
		var y = matrix.ty + CairoGraphics.graphics.__bounds.y;
		pattern = (lime_graphics_cairo__$CairoPattern_CairoPattern_$Impl_$().default).createRadial(x,y,0,x,y,Math.abs((point.x - matrix.tx) / 2));
		break;
	}
	var rgb;
	var alpha;
	var r;
	var g;
	var b;
	var ratio;
	var _g1 = 0;
	var _g = colors.length;
	while(_g1 < _g) {
		var i = _g1++;
		rgb = colors[i];
		alpha = alphas[i];
		r = ((rgb & 16711680) >>> 16) / 255;
		g = ((rgb & 65280) >>> 8) / 255;
		b = (rgb & 255) / 255;
		ratio = ratios[i] / 255;
		if(ratio < 0) {
			ratio = 0;
		}
		if(ratio > 1) {
			ratio = 1;
		}
		(lime_graphics_cairo__$CairoPattern_CairoPattern_$Impl_$().default).addColorStopRGBA(pattern,ratio,r,g,b,alpha);
	}
	if(point != null) {
		(openfl_geom_Point().default).__pool.release(point);
	}
	if(point2 != null) {
		(openfl_geom_Point().default).__pool.release(point2);
	}
	if(releaseMatrix) {
		(openfl_geom_Matrix().default).__pool.release(matrix);
	}
	var mat = (lime_graphics_cairo__$CairoPattern_CairoPattern_$Impl_$().default).get_matrix(pattern);
	mat.tx = CairoGraphics.bounds.x;
	mat.ty = CairoGraphics.bounds.y;
	(lime_graphics_cairo__$CairoPattern_CairoPattern_$Impl_$().default).set_matrix(pattern,mat);
	return pattern;
}
CairoGraphics.createImagePattern = function(bitmapFill,matrix,bitmapRepeat,smooth) {
	var pattern = (lime_graphics_cairo__$CairoPattern_CairoPattern_$Impl_$().default).createForSurface(bitmapFill.getSurface());
	(lime_graphics_cairo__$CairoPattern_CairoPattern_$Impl_$().default).set_filter(pattern,smooth && CairoGraphics.allowSmoothing ? 1 : 3);
	if(bitmapRepeat) {
		(lime_graphics_cairo__$CairoPattern_CairoPattern_$Impl_$().default).set_extend(pattern,1);
	}
	CairoGraphics.fillPatternMatrix = matrix;
	return pattern;
}
CairoGraphics.drawRoundRect = function(x,y,width,height,ellipseWidth,ellipseHeight) {
	if(ellipseHeight == null) {
		ellipseHeight = ellipseWidth;
	}
	ellipseWidth *= 0.5;
	ellipseHeight *= 0.5;
	if(ellipseWidth > width / 2) {
		ellipseWidth = width / 2;
	}
	if(ellipseHeight > height / 2) {
		ellipseHeight = height / 2;
	}
	var xe = x + width;
	var ye = y + height;
	var cx1 = -ellipseWidth + ellipseWidth * CairoGraphics.SIN45;
	var cx2 = -ellipseWidth + ellipseWidth * CairoGraphics.TAN22;
	var cy1 = -ellipseHeight + ellipseHeight * CairoGraphics.SIN45;
	var cy2 = -ellipseHeight + ellipseHeight * CairoGraphics.TAN22;
	CairoGraphics.cairo.moveTo(xe,ye - ellipseHeight);
	CairoGraphics.quadraticCurveTo(xe,ye + cy2,xe + cx1,ye + cy1);
	CairoGraphics.quadraticCurveTo(xe + cx2,ye,xe - ellipseWidth,ye);
	CairoGraphics.cairo.lineTo(x + ellipseWidth,ye);
	CairoGraphics.quadraticCurveTo(x - cx2,ye,x - cx1,ye + cy1);
	CairoGraphics.quadraticCurveTo(x,ye + cy2,x,ye - ellipseHeight);
	CairoGraphics.cairo.lineTo(x,y + ellipseHeight);
	CairoGraphics.quadraticCurveTo(x,y - cy2,x - cx1,y - cy1);
	CairoGraphics.quadraticCurveTo(x - cx2,y,x + ellipseWidth,y);
	CairoGraphics.cairo.lineTo(xe - ellipseWidth,y);
	CairoGraphics.quadraticCurveTo(xe + cx2,y,xe + cx1,y - cy1);
	CairoGraphics.quadraticCurveTo(xe,y - cy2,xe,y + ellipseHeight);
	CairoGraphics.cairo.lineTo(xe,ye - ellipseHeight);
}
CairoGraphics.endFill = function() {
	CairoGraphics.cairo.newPath();
	CairoGraphics.playCommands(CairoGraphics.fillCommands,false);
	CairoGraphics.fillCommands.clear();
}
CairoGraphics.endStroke = function() {
	CairoGraphics.cairo.newPath();
	CairoGraphics.playCommands(CairoGraphics.strokeCommands,true);
	CairoGraphics.cairo.closePath();
	CairoGraphics.strokeCommands.clear();
}
CairoGraphics.hitTest = function(graphics,x,y) {
	return false;
}
CairoGraphics.isCCW = function(x1,y1,x2,y2,x3,y3) {
	return (x2 - x1) * (y3 - y1) - (y2 - y1) * (x3 - x1) < 0;
}
CairoGraphics.normalizeUVT = function(uvt,skipT) {
	if(skipT == null) {
		skipT = false;
	}
	var max = -Infinity;
	var tmp = -Infinity;
	var len = uvt.data.get_length();
	var _g1 = 1;
	var _g = len + 1;
	while(_g1 < _g) {
		var t = _g1++;
		if(skipT && t % 3 == 0) {
			continue;
		}
		tmp = uvt.data.get(t - 1);
		if(max < tmp) {
			max = tmp;
		}
	}
	if(!skipT) {
		return { max : max, uvt : uvt};
	}
	var result = (openfl__$Vector_Vector_$Impl_$().default).toFloatVector(null);
	var _g11 = 1;
	var _g2 = len + 1;
	while(_g11 < _g2) {
		var t1 = _g11++;
		if(skipT && t1 % 3 == 0) {
			continue;
		}
		var x = uvt.data.get(t1 - 1);
		result.data.push(x);
	}
	return { max : max, uvt : result};
}
CairoGraphics.playCommands = function(commands,stroke) {
	if(stroke == null) {
		stroke = false;
	}
	if(commands.get_length() == 0) {
		return;
	}
	CairoGraphics.bounds = CairoGraphics.graphics.__bounds;
	var offsetX = CairoGraphics.bounds.x;
	var offsetY = CairoGraphics.bounds.y;
	var positionX = 0.0;
	var positionY = 0.0;
	var closeGap = false;
	var startX = 0.0;
	var startY = 0.0;
	var setStart = false;
	CairoGraphics.cairo.set_fillRule(1);
	CairoGraphics.cairo.set_antialias(3);
	var hasPath = false;
	var data = new (openfl__$internal_renderer_DrawCommandReader().default)(commands);
	var x;
	var y;
	var width;
	var height;
	var kappa = .5522848;
	var ox;
	var oy;
	var xe;
	var ye;
	var xm;
	var ym;
	var r;
	var g;
	var b;
	var _g = 0;
	var _g1 = commands.types;
	try {
		while(_g < _g1.length) {
			var type = _g1[_g];
			++_g;
			switch((Type().default).enumIndex(type)) {
			case 0:
				var c = data.readBeginBitmapFill();
				CairoGraphics.fillPattern = CairoGraphics.createImagePattern(c.obj(0),c.obj(1),c.bool(0),c.bool(1));
				CairoGraphics.bitmapFill = c.obj(0);
				CairoGraphics.bitmapRepeat = c.bool(0);
				CairoGraphics.hasFill = true;
				break;
			case 1:
				var c1 = data.readBeginFill();
				if(c1["float"](0) < 0.005) {
					CairoGraphics.hasFill = false;
				} else {
					if(CairoGraphics.fillPattern != null) {
						CairoGraphics.fillPatternMatrix = null;
					}
					CairoGraphics.fillPattern = (lime_graphics_cairo__$CairoPattern_CairoPattern_$Impl_$().default).createRGBA(((c1["int"](0) & 16711680) >>> 16) / 255,((c1["int"](0) & 65280) >>> 8) / 255,(c1["int"](0) & 255) / 255,c1["float"](0));
					CairoGraphics.hasFill = true;
				}
				CairoGraphics.bitmapFill = null;
				break;
			case 2:
				var c2 = data.readBeginGradientFill();
				if(CairoGraphics.fillPattern != null) {
					CairoGraphics.fillPatternMatrix = null;
				}
				CairoGraphics.fillPattern = CairoGraphics.createGradientPattern(c2.obj(0),c2.iArr(0),c2.fArr(0),c2.iArr(1),c2.obj(1),c2.obj(2),c2.obj(3),c2["float"](0));
				CairoGraphics.hasFill = true;
				CairoGraphics.bitmapFill = null;
				break;
			case 3:
				var c3 = data.readCubicCurveTo();
				hasPath = true;
				CairoGraphics.cairo.curveTo(c3["float"](0) - offsetX,c3["float"](1) - offsetY,c3["float"](2) - offsetX,c3["float"](3) - offsetY,c3["float"](4) - offsetX,c3["float"](5) - offsetY);
				break;
			case 4:
				var c4 = data.readCurveTo();
				hasPath = true;
				CairoGraphics.quadraticCurveTo(c4["float"](0) - offsetX,c4["float"](1) - offsetY,c4["float"](2) - offsetX,c4["float"](3) - offsetY);
				break;
			case 5:
				var c5 = data.readDrawCircle();
				hasPath = true;
				CairoGraphics.cairo.moveTo(c5["float"](0) - offsetX + c5["float"](2),c5["float"](1) - offsetY);
				CairoGraphics.cairo.arc(c5["float"](0) - offsetX,c5["float"](1) - offsetY,c5["float"](2),0,Math.PI * 2);
				break;
			case 6:
				var c6 = data.readDrawEllipse();
				hasPath = true;
				x = c6["float"](0);
				y = c6["float"](1);
				width = c6["float"](2);
				height = c6["float"](3);
				x -= offsetX;
				y -= offsetY;
				ox = width / 2 * kappa;
				oy = height / 2 * kappa;
				xe = x + width;
				ye = y + height;
				xm = x + width / 2;
				ym = y + height / 2;
				CairoGraphics.cairo.moveTo(x,ym);
				CairoGraphics.cairo.curveTo(x,ym - oy,xm - ox,y,xm,y);
				CairoGraphics.cairo.curveTo(xm + ox,y,xe,ym - oy,xe,ym);
				CairoGraphics.cairo.curveTo(xe,ym + oy,xm + ox,ye,xm,ye);
				CairoGraphics.cairo.curveTo(xm - ox,ye,x,ym + oy,x,ym);
				break;
			case 7:
				var c7 = data.readDrawRect();
				hasPath = true;
				CairoGraphics.cairo.rectangle(c7["float"](0) - offsetX,c7["float"](1) - offsetY,c7["float"](2),c7["float"](3));
				break;
			case 8:
				var c8 = data.readDrawRoundRect();
				hasPath = true;
				CairoGraphics.drawRoundRect(c8["float"](0) - offsetX,c8["float"](1) - offsetY,c8["float"](2),c8["float"](3),c8["float"](4),c8.obj(0));
				break;
			case 10:
				var c9 = data.readDrawTriangles();
				var v = c9.obj(0);
				var ind = c9.obj(1);
				var uvt = c9.obj(2);
				var colorFill = CairoGraphics.bitmapFill == null;
				if(colorFill && uvt != null) {
					throw "__break__";
				}
				var width1 = 0;
				var height1 = 0;
				var currentMatrix = CairoGraphics.graphics.__renderTransform.__toMatrix3();
				if(!colorFill) {
					if(uvt == null) {
						uvt = (openfl__$Vector_Vector_$Impl_$().default).toFloatVector(null);
						var _g3 = 0;
						var _g2 = (Std().default)["int"](v.data.get_length() / 2);
						while(_g3 < _g2) {
							var i = _g3++;
							var x1 = v.data.get(i * 2);
							uvt.data.push(x1 - offsetX / CairoGraphics.bitmapFill.width);
							var x2 = v.data.get(i * 2 + 1);
							uvt.data.push(x2 - offsetY / CairoGraphics.bitmapFill.height);
						}
					}
					var skipT = c9.obj(2).data.get_length() != v.data.get_length();
					var normalizedUVT = CairoGraphics.normalizeUVT(uvt,skipT);
					var maxUVT = normalizedUVT.max;
					uvt = normalizedUVT.uvt;
					if(maxUVT > 1) {
						width1 = (Std().default)["int"](CairoGraphics.bounds.width);
						height1 = (Std().default)["int"](CairoGraphics.bounds.height);
					} else {
						width1 = CairoGraphics.bitmapFill.width;
						height1 = CairoGraphics.bitmapFill.height;
					}
				}
				var i1 = 0;
				var l = ind.data.get_length();
				var a_;
				var b_;
				var c_;
				var iax;
				var iay;
				var ibx;
				var iby;
				var icx;
				var icy;
				var x11;
				var y1;
				var x21;
				var y2;
				var x3;
				var y3;
				var uvx1;
				var uvy1;
				var uvx2;
				var uvy2;
				var uvx3;
				var uvy3;
				var denom;
				var t1;
				var t2;
				var t3;
				var t4;
				var dx;
				var dy;
				var matrix = new (lime_math_Matrix3().default)();
				CairoGraphics.cairo.set_antialias(1);
				while(i1 < l) {
					a_ = i1;
					b_ = i1 + 1;
					c_ = i1 + 2;
					iax = ind.data.get(a_) * 2;
					iay = ind.data.get(a_) * 2 + 1;
					ibx = ind.data.get(b_) * 2;
					iby = ind.data.get(b_) * 2 + 1;
					icx = ind.data.get(c_) * 2;
					icy = ind.data.get(c_) * 2 + 1;
					x11 = v.data.get(iax) - offsetX;
					y1 = v.data.get(iay) - offsetY;
					x21 = v.data.get(ibx) - offsetX;
					y2 = v.data.get(iby) - offsetY;
					x3 = v.data.get(icx) - offsetX;
					y3 = v.data.get(icy) - offsetY;
					var _g21 = c9.obj(3);
					switch(_g21) {
					case 0:
						if(CairoGraphics.isCCW(x11,y1,x21,y2,x3,y3)) {
							i1 += 3;
							continue;
						}
						break;
					case 2:
						if(!CairoGraphics.isCCW(x11,y1,x21,y2,x3,y3)) {
							i1 += 3;
							continue;
						}
						break;
					default:
					}
					if(colorFill) {
						CairoGraphics.cairo.newPath();
						CairoGraphics.cairo.moveTo(x11,y1);
						CairoGraphics.cairo.lineTo(x21,y2);
						CairoGraphics.cairo.lineTo(x3,y3);
						CairoGraphics.cairo.closePath();
						if(!CairoGraphics.hitTesting) {
							CairoGraphics.cairo.fillPreserve();
						}
						i1 += 3;
						continue;
					}
					CairoGraphics.cairo.set_matrix(CairoGraphics.graphics.__renderTransform.__toMatrix3());
					CairoGraphics.cairo.newPath();
					CairoGraphics.cairo.moveTo(x11,y1);
					CairoGraphics.cairo.lineTo(x21,y2);
					CairoGraphics.cairo.lineTo(x3,y3);
					CairoGraphics.cairo.closePath();
					uvx1 = uvt.data.get(iax) * width1;
					uvx2 = uvt.data.get(ibx) * width1;
					uvx3 = uvt.data.get(icx) * width1;
					uvy1 = uvt.data.get(iay) * height1;
					uvy2 = uvt.data.get(iby) * height1;
					uvy3 = uvt.data.get(icy) * height1;
					denom = uvx1 * (uvy3 - uvy2) - uvx2 * uvy3 + uvx3 * uvy2 + (uvx2 - uvx3) * uvy1;
					if(denom == 0) {
						i1 += 3;
						continue;
					}
					x11 *= currentMatrix.a;
					x21 *= currentMatrix.a;
					x3 *= currentMatrix.a;
					y1 *= currentMatrix.d;
					y2 *= currentMatrix.d;
					y3 *= currentMatrix.d;
					t1 = -(uvy1 * (x3 - x21) - uvy2 * x3 + uvy3 * x21 + (uvy2 - uvy3) * x11) / denom;
					t2 = (uvy2 * y3 + uvy1 * (y2 - y3) - uvy3 * y2 + (uvy3 - uvy2) * y1) / denom;
					t3 = (uvx1 * (x3 - x21) - uvx2 * x3 + uvx3 * x21 + (uvx2 - uvx3) * x11) / denom;
					t4 = -(uvx2 * y3 + uvx1 * (y2 - y3) - uvx3 * y2 + (uvx3 - uvx2) * y1) / denom;
					dx = (uvx1 * (uvy3 * x21 - uvy2 * x3) + uvy1 * (uvx2 * x3 - uvx3 * x21) + (uvx3 * uvy2 - uvx2 * uvy3) * x11) / denom;
					dy = (uvx1 * (uvy3 * y2 - uvy2 * y3) + uvy1 * (uvx2 * y3 - uvx3 * y2) + (uvx3 * uvy2 - uvx2 * uvy3) * y1) / denom;
					matrix.setTo(t1,t2,t3,t4,dx,dy);
					CairoGraphics.cairo.set_matrix(matrix);
					CairoGraphics.cairo.set_source(CairoGraphics.fillPattern);
					if(!CairoGraphics.hitTesting) {
						CairoGraphics.cairo.fill();
					}
					i1 += 3;
				}
				break;
			case 12:
				var c10 = data.readLineBitmapStyle();
				if(stroke && CairoGraphics.hasStroke) {
					CairoGraphics.closePath();
				}
				CairoGraphics.cairo.moveTo(positionX - offsetX,positionY - offsetY);
				CairoGraphics.strokePattern = CairoGraphics.createImagePattern(c10.obj(0),c10.obj(1),c10.bool(0),c10.bool(1));
				CairoGraphics.hasStroke = true;
				break;
			case 13:
				var c11 = data.readLineGradientStyle();
				if(stroke && CairoGraphics.hasStroke) {
					CairoGraphics.closePath();
				}
				CairoGraphics.cairo.moveTo(positionX - offsetX,positionY - offsetY);
				CairoGraphics.strokePattern = CairoGraphics.createGradientPattern(c11.obj(0),c11.iArr(0),c11.fArr(0),c11.iArr(1),c11.obj(1),c11.obj(2),c11.obj(3),c11["float"](0));
				CairoGraphics.hasStroke = true;
				break;
			case 14:
				var c12 = data.readLineStyle();
				if(stroke && CairoGraphics.hasStroke) {
					CairoGraphics.closePath(true);
				}
				CairoGraphics.cairo.moveTo(positionX - offsetX,positionY - offsetY);
				if(c12.obj(0) == null) {
					CairoGraphics.hasStroke = false;
				} else {
					CairoGraphics.hasStroke = true;
					CairoGraphics.cairo.set_lineWidth(c12.obj(0) > 0 ? c12.obj(0) : 1);
					if(c12.obj(3) == null) {
						CairoGraphics.cairo.set_lineJoin(1);
					} else {
						var tmp = CairoGraphics.cairo;
						var _g22 = c12.obj(3);
						var tmp1;
						switch(_g22) {
						case 0:
							tmp1 = 2;
							break;
						case 1:
							tmp1 = 0;
							break;
						default:
							tmp1 = 1;
						}
						tmp.set_lineJoin(tmp1);
					}
					if(c12.obj(2) == null) {
						CairoGraphics.cairo.set_lineCap(1);
					} else {
						var tmp2 = CairoGraphics.cairo;
						var _g23 = c12.obj(2);
						var tmp3;
						switch(_g23) {
						case 0:
							tmp3 = 0;
							break;
						case 2:
							tmp3 = 2;
							break;
						default:
							tmp3 = 1;
						}
						tmp2.set_lineCap(tmp3);
					}
					CairoGraphics.cairo.set_miterLimit(c12["float"](1));
					r = ((c12["int"](0) & 16711680) >>> 16) / 255;
					g = ((c12["int"](0) & 65280) >>> 8) / 255;
					b = (c12["int"](0) & 255) / 255;
					if(c12["float"](0) == 1) {
						CairoGraphics.strokePattern = (lime_graphics_cairo__$CairoPattern_CairoPattern_$Impl_$().default).createRGB(r,g,b);
					} else {
						CairoGraphics.strokePattern = (lime_graphics_cairo__$CairoPattern_CairoPattern_$Impl_$().default).createRGBA(r,g,b,c12["float"](0));
					}
				}
				break;
			case 15:
				var c13 = data.readLineTo();
				hasPath = true;
				CairoGraphics.cairo.lineTo(c13["float"](0) - offsetX,c13["float"](1) - offsetY);
				positionX = c13["float"](0);
				positionY = c13["float"](1);
				if(positionX == startX && positionY == startY) {
					closeGap = true;
				}
				break;
			case 16:
				var c14 = data.readMoveTo();
				CairoGraphics.cairo.moveTo(c14["float"](0) - offsetX,c14["float"](1) - offsetY);
				positionX = c14["float"](0);
				positionY = c14["float"](1);
				if(setStart) {
					closeGap = true;
				}
				startX = c14["float"](0);
				startY = c14["float"](1);
				setStart = true;
				break;
			case 18:
				data.readWindingEvenOdd();
				CairoGraphics.cairo.set_fillRule(1);
				break;
			case 19:
				data.readWindingNonZero();
				CairoGraphics.cairo.set_fillRule(0);
				break;
			default:
				data.skip(type);
			}
		}
	} catch( e ) { if( e != "__break__" ) throw e; }
	data.destroy();
	if(hasPath) {
		if(stroke && CairoGraphics.hasStroke) {
			if(CairoGraphics.hasFill && closeGap) {
				CairoGraphics.cairo.lineTo(startX - offsetX,startY - offsetY);
				CairoGraphics.closePath(false);
			} else if(closeGap && positionX == startX && positionY == startY) {
				CairoGraphics.closePath(false);
			}
			CairoGraphics.cairo.set_source(CairoGraphics.strokePattern);
			if(!CairoGraphics.hitTesting) {
				CairoGraphics.cairo.strokePreserve();
			}
		}
		if(!stroke && CairoGraphics.hasFill) {
			CairoGraphics.cairo.translate(-CairoGraphics.bounds.x,-CairoGraphics.bounds.y);
			if(CairoGraphics.fillPatternMatrix != null) {
				var matrix1 = (openfl_geom_Matrix().default).__pool.get();
				matrix1.copyFrom(CairoGraphics.fillPatternMatrix);
				matrix1.invert();
				if(CairoGraphics.pendingMatrix != null) {
					matrix1.concat(CairoGraphics.pendingMatrix);
				}
				(lime_graphics_cairo__$CairoPattern_CairoPattern_$Impl_$().default).set_matrix(CairoGraphics.fillPattern,matrix1.__toMatrix3());
				(openfl_geom_Matrix().default).__pool.release(matrix1);
			}
			CairoGraphics.cairo.set_source(CairoGraphics.fillPattern);
			if(CairoGraphics.pendingMatrix != null) {
				CairoGraphics.cairo.transform(CairoGraphics.pendingMatrix.__toMatrix3());
				if(!CairoGraphics.hitTesting) {
					CairoGraphics.cairo.fillPreserve();
				}
				CairoGraphics.cairo.transform(CairoGraphics.inversePendingMatrix.__toMatrix3());
			} else if(!CairoGraphics.hitTesting) {
				CairoGraphics.cairo.fillPreserve();
			}
			CairoGraphics.cairo.translate(CairoGraphics.bounds.x,CairoGraphics.bounds.y);
			CairoGraphics.cairo.closePath();
		}
	}
}
CairoGraphics.quadraticCurveTo = function(cx,cy,x,y) {
	var current = null;
	if(!CairoGraphics.cairo.get_hasCurrentPoint()) {
		CairoGraphics.cairo.moveTo(cx,cy);
		current = new (lime_math_Vector2().default)(cx,cy);
	} else {
		current = CairoGraphics.cairo.get_currentPoint();
	}
	var cx1 = current.x + 0.66666666666666663 * (cx - current.x);
	var cy1 = current.y + 0.66666666666666663 * (cy - current.y);
	var cx2 = x + 0.66666666666666663 * (cx - x);
	var cy2 = y + 0.66666666666666663 * (cy - y);
	CairoGraphics.cairo.curveTo(cx1,cy1,cx2,cy2,x,y);
}
CairoGraphics.render = function(graphics,renderSession,parentTransform) {
}
CairoGraphics.renderMask = function(graphics,renderSession) {
	if(graphics.__commands.get_length() != 0) {
		var cairo = renderSession.cairo;
		var positionX = 0.0;
		var positionY = 0.0;
		var offsetX = 0;
		var offsetY = 0;
		var data = new (openfl__$internal_renderer_DrawCommandReader().default)(graphics.__commands);
		var x;
		var y;
		var width;
		var height;
		var kappa = .5522848;
		var ox;
		var oy;
		var xe;
		var ye;
		var xm;
		var ym;
		var _g = 0;
		var _g1 = graphics.__commands.types;
		while(_g < _g1.length) {
			var type = _g1[_g];
			++_g;
			switch((Type().default).enumIndex(type)) {
			case 3:
				var c = data.readCubicCurveTo();
				cairo.curveTo(c["float"](0) - offsetX,c["float"](1) - offsetY,c["float"](2) - offsetX,c["float"](3) - offsetY,c["float"](4) - offsetX,c["float"](5) - offsetY);
				positionX = c["float"](4);
				positionY = c["float"](4);
				break;
			case 4:
				var c1 = data.readCurveTo();
				CairoGraphics.quadraticCurveTo(c1["float"](0) - offsetX,c1["float"](1) - offsetY,c1["float"](2) - offsetX,c1["float"](3) - offsetY);
				positionX = c1["float"](2);
				positionY = c1["float"](3);
				break;
			case 5:
				var c2 = data.readDrawCircle();
				cairo.arc(c2["float"](0) - offsetX,c2["float"](1) - offsetY,c2["float"](2),0,Math.PI * 2);
				break;
			case 6:
				var c3 = data.readDrawEllipse();
				x = c3["float"](0);
				y = c3["float"](1);
				width = c3["float"](2);
				height = c3["float"](3);
				x -= offsetX;
				y -= offsetY;
				ox = width / 2 * kappa;
				oy = height / 2 * kappa;
				xe = x + width;
				ye = y + height;
				xm = x + width / 2;
				ym = y + height / 2;
				cairo.moveTo(x,ym);
				cairo.curveTo(x,ym - oy,xm - ox,y,xm,y);
				cairo.curveTo(xm + ox,y,xe,ym - oy,xe,ym);
				cairo.curveTo(xe,ym + oy,xm + ox,ye,xm,ye);
				cairo.curveTo(xm - ox,ye,x,ym + oy,x,ym);
				break;
			case 7:
				var c4 = data.readDrawRect();
				cairo.rectangle(c4["float"](0) - offsetX,c4["float"](1) - offsetY,c4["float"](2),c4["float"](3));
				break;
			case 8:
				var c5 = data.readDrawRoundRect();
				CairoGraphics.drawRoundRect(c5["float"](0) - offsetX,c5["float"](1) - offsetY,c5["float"](2),c5["float"](3),c5["float"](4),c5.obj(0));
				break;
			case 15:
				var c6 = data.readLineTo();
				cairo.lineTo(c6["float"](0) - offsetX,c6["float"](1) - offsetY);
				positionX = c6["float"](0);
				positionY = c6["float"](1);
				break;
			case 16:
				var c7 = data.readMoveTo();
				cairo.moveTo(c7["float"](0) - offsetX,c7["float"](1) - offsetY);
				positionX = c7["float"](0);
				positionY = c7["float"](1);
				break;
			default:
				data.skip(type);
			}
		}
		data.destroy();
	}
}
CairoGraphics.SIN45 = 0.70710678118654752440084436210485
CairoGraphics.TAN22 = 0.4142135623730950488016887242097
CairoGraphics.fillCommands = new (openfl__$internal_renderer_DrawCommandBuffer().default)()
CairoGraphics.strokeCommands = new (openfl__$internal_renderer_DrawCommandBuffer().default)()

// Export

exports.default = CairoGraphics;