declare namespace openfl.display {
	
	/**
	 * The StageAlign class provides constant values to use for the
	 * `Stage.align` property.
	 */
	export enum StageAlign {
		
		/**
		 * Specifies that the Stage is aligned at the bottom.
		 */
		BOTTOM = 0,
		
		/**
		 * Specifies that the Stage is aligned on the left.
		 */
		BOTTOM_LEFT = 1,
		
		/**
		 * Specifies that the Stage is aligned to the right.
		 */
		BOTTOM_RIGHT = 2,
		
		/**
		 * Specifies that the Stage is aligned on the left.
		 */
		LEFT = 3,
		
		/**
		 * Specifies that the Stage is aligned to the right.
		 */
		RIGHT = 4,
		
		/**
		 * Specifies that the Stage is aligned at the top.
		 */
		TOP = 5,
		
		/**
		 * Specifies that the Stage is aligned on the left.
		 */
		TOP_LEFT = 6,
		
		/**
		 * Specifies that the Stage is aligned to the right.
		 */
		TOP_RIGHT = 7
		
	}
	
}


export default openfl.display.StageAlign;