declare namespace openfl.text {
	
	/**
	 * The FontStyle class provides values for the TextRenderer class.
	 */
	export enum FontStyle {
		
		/**
		 * Defines the bold style of a font for the `fontStyle` parameter
		 * in the `setAdvancedAntiAliasingTable()` method. Use the syntax
		 * `FontStyle.BOLD`.
		 */
		BOLD = 0,
		
		/**
		 * Defines the italic style of a font for the `fontStyle`
		 * parameter in the `setAdvancedAntiAliasingTable()` method. Use
		 * the syntax `FontStyle.ITALIC`.
		 */
		BOLD_ITALIC = 1,
		
		/**
		 * Defines the italic style of a font for the `fontStyle`
		 * parameter in the `setAdvancedAntiAliasingTable()` method. Use
		 * the syntax `FontStyle.ITALIC`.
		 */
		ITALIC = 2,
		
		/**
		 * Defines the plain style of a font for the `fontStyle` parameter
		 * in the `setAdvancedAntiAliasingTable()` method. Use the syntax
		 * `FontStyle.REGULAR`.
		 */
		REGULAR = 3
		
	}
	
}


export default openfl.text.FontStyle;