declare namespace openfl.text {
	
	/**
	 * The TextFormatAlign class provides values for text alignment in the
	 * TextFormat class.
	 */
	export enum TextFormatAlign {
		
		/**
		 * Constant; centers the text in the text field. Use the syntax
		 * `TextFormatAlign.CENTER`.
		 */
		CENTER = 0,
		
		END = 1,
		
		/**
		 * Constant; justifies text within the text field. Use the syntax
		 * `TextFormatAlign.JUSTIFY`.
		 */
		JUSTIFY = 2,
		
		/**
		 * Constant; aligns text to the left within the text field. Use the syntax
		 * `TextFormatAlign.LEFT`.
		 */
		LEFT = 3,
		
		/**
		 * Constant; aligns text to the right within the text field. Use the syntax
		 * `TextFormatAlign.RIGHT`.
		 */
		RIGHT = 4,
		
		START = 5
		
	}
	
}


export default openfl.text.TextFormatAlign;